#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 NAME

Autoload - Autoload WDB functions and methods

=head1 Description

This module automatically loads undefined methods and subroutines from the
$LIB_DIR/WDB or the $LIB_DIR/auto directories.

=head1 Public Methods
=cut#--------------------------------------------------------------------------

#package  WDB::Autoload;
use English;                    # Use long "english" variable names 


#
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#.PURPOSE	Autoloads undfined functions from $LIB_DIR/auto/
#
#.REMARKS
#
#.RETURNS	The return value of the loaded function (dies on error!) 
#------------------------------------------------------------------------------
sub AUTOLOAD
{
    my( $program ) = $AUTOLOAD;
    my($arg, $ret);
    
    print main::DEBUG "AUTOLOAD: $AUTOLOAD\n"  if $main::debug;
    $program =~ s/.*:://;
    print main::DEBUG "Loading: $program\n"  if $main::debug;
    #print main::DEBUG "Loading: $CONFIG_DIR/auto/$program\n"  if $main::debug;
    #open(FILE, "$CONFIG_DIR/auto/$program.pm") || WDB::Error::Fatal("Can't load $program : $!\n");
    if ( ! open(AUTOLOADFILE, "$WDB::Eval::WDB_DIR/auto/$program.pm") ) {
        if ( ! open(AUTOLOADFILE, "$WDB::Eval::AUTOPATH/$program.pm") ) {
    	  WDB::Error::Fatal("Can't load $program : $!\n");
	}
    }
    eval( join('',<AUTOLOADFILE>) );
	    WDB::Error::Fatal("Can't define $program: $@") if $@;
    $ret = eval( '&' . $program . '(@_)' );
	    WDB::Error::Fatal("Can't run $program: $@") if $@;
    return $ret;
}

1;
