#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 action_change

The 'change' action for WDB.

=head1 Description

This module is automatically loaded by WDB when the 'change' action is
used.

=head1 Functions
=cut#--------------------------------------------------------------------------


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 action_change

Queries the database.

=cut
#------------------------------------------------------------------------------
sub action_change
{
    my($cgi,$fdf) = @_;
    my($dbi,@keys,$key);
    my($start,$maxrows,$rows);

    print main::DEBUG "\n*** action_change ***\n\n" if $main::debug;

    #------------------------
    # LOAD DBI
    #------------------------
    $dbi = load_dbi($fdf->{'DATABASE'});

    #------------------------
    # COMPOSE SQL
    #------------------------

    $fdf->verify_query( $cgi );	

    if ( ! $dbi->change( $cgi, $fdf ) ) {
        my($err_code,$err_num, $err_msg) = $dbi->getLastError();
	if ($err_code eq $WDB::DBI::ERR_UNIQ ) {
	    $WDB::Eval::ERRORMSG = '<FONT SIZE=+1 COLOR=red>'
		    . $main::MSG{CANT_UPDATE} .'<BR>'
		    . $main::MSG{DBERR_UNIQE}
		    .'</FONT>';
	} else {
	    $WDB::Eval::ERRORMSG = '<FONT SIZE=+1 COLOR=red>'
		    . $main::MSG{CANT_UPDATE} .'<BR>'
		    .'</FONT>'
		    ."( [$err_code][$err_num] <I>$err_msg</I>)"
		    ;
	}
	$fdf->layout( ( $cgi->param('wdb_lastldf') ? $cgi->param('wdb_lastldf') : 'change_form') );
	$fdf->print_html;
	return;
    }

    #------------------------
    # POST CHANGE ACTION ?
    #------------------------
    if ( $fdf->{'POST_CHANGE'} ) {
	$WDB::Eval::dbi = $dbi;
	WDB::Eval::eval($fdf->{'NAME'}." POST_CHANGE", $fdf->{'POST_CHANGE'} );
    }

    #------------------------
    # PRINT RESULT.
    #------------------------

    $fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'change') );
    $fdf->print_html;

    #$dbi->close;
}

1;
