#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 action_delete

The 'delete' action for WDB.

=head1 Description

Deletes a row in the database. 

This module is automatically loaded by WDB when the 'delete' action is
used.

=head1 Functions
=cut#--------------------------------------------------------------------------


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 action_delete

Deletes a row from the database

=cut
#------------------------------------------------------------------------------
sub action_delete
{
    my($cgi,$fdf) = @_;
    my($dbi,@keys,$key);

    print main::DEBUG "*** action_delete ***\n" if $main::debug;

    #-----------
    # Set keys
    #-----------
    if ( defined $in{wdb_keys} ) {
	@keys = split( /::/, $in{wdb_keys});
	foreach $key ( @{$fdf->{keys}} ) {
	   $in{$key} = shift(@keys);
	   $fdf->{field}{$key}->set_value( $in{$key} );
	}
    } else {
	die "No keys defined for delete !";
    }

    if ( ! $fdf->verify($cgi) ) {
	WDB::Error::Fatal("Error in delete?");
    }
    #------------------------
    # LOAD DBI
    #------------------------
    $dbi = load_dbi($fdf->{'DATABASE'});

    #------------------------
    # PRE DELETE ACTION ?
    #------------------------
    if ( $fdf->{'PRE_DELETE'} ) {
	$WDB::Eval::dbi = $dbi;
	WDB::Eval::eval($fdf->{'NAME'}." PRE_DELETE", $fdf->{'PRE_DELETE'} );
    }

    #------------------------
    # COMPOSE SQL
    #------------------------

    $dbi->delete( $cgi, $fdf );

    #------------------------
    # POST DELETE ACTION ?
    #------------------------
    if ( $fdf->{'POST_DELETE'} ) {
	$WDB::Eval::dbi = $dbi;
	WDB::Eval::eval($fdf->{'NAME'}." POST_DELETE", $fdf->{'POST_DELETE'} );
    }

    #------------------------
    # PRINT RESULT.
    #------------------------

    $fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'delete') );
    $fdf->print_html;
    #$dbi->close;
}

1;
