#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 action_insert

The 'insert' action for WDB.

=head1 Description

Inserts a row in the database. Called from the form generated by the 'ins_form'
action.

This module is automatically loaded by WDB when the 'insert' action is
used.

=head1 Functions
=cut#--------------------------------------------------------------------------


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 action_insert

Inserts a row in the database

=cut
#------------------------------------------------------------------------------
sub action_insert
{
    my($cgi,$fdf) = @_;
    my($dbi,@keys,$key);

    print main::DEBUG "*** action_insert ***\n" if $main::debug;

    #------------------------
    # LOAD DBI
    #------------------------
    $dbi = load_dbi($fdf->{'DATABASE'});

    #------------------------
    # PRE INSERT ACTION ?
    #------------------------
    if ( $fdf->{'PRE_INSERT'} ) {
	$WDB::Eval::dbi = $dbi;
	WDB::Eval::eval($fdf->{'NAME'}." PRE_INSERT", $fdf->{'PRE_INSERT'} );
    }

    #------------------------
    # VERIFY
    #------------------------
    if ( ! $fdf->verify($cgi) ) {

        #-----------------------------------------------------
        # Print the insert form again with error messages.
        #-----------------------------------------------------
        #$fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'ins_form') );
	$fdf->layout( ( $cgi->param('wdb_lastldf') ? $cgi->param('wdb_lastldf') : 'ins_form') );
	$fdf->print_html;
	return;
    }

    #------------------------
    # COMPOSE SQL
    #------------------------

    if ( ! $dbi->insert( $cgi, $fdf ) ) {
        my($err_code,$err_num, $err_msg) = $dbi->getLastError();
	if ($err_code eq $WDB::DBI::ERR_UNIQ ) {
	    $WDB::Eval::ERRORMSG = '<FONT SIZE=+1 COLOR=red>'
		    . $main::MSG{CANT_INSERT} .'<BR>'
		    . $main::MSG{DBERR_UNIQE}
		    .'</FONT>';
	} else {
	    $WDB::Eval::ERRORMSG = '<FONT SIZE=+1 COLOR=red>'
		    . $main::MSG{CANT_INSERT} .'<BR>'
		    .'</FONT>'
		    ."( [$err_code][$err_num] <I>$err_msg</I>)"
		    ;
	}
	WDB::Error::Log("Oracle Error:\n( [$err_code][$err_num] $err_msg)\n");
	$fdf->layout( ( $cgi->param('wdb_lastldf') ? $cgi->param('wdb_lastldf') : 'ins_form') );
	$fdf->print_html;
	return;
    }
    #------------------------
    # POST INSERT ACTION ?
    #------------------------
    if ( $fdf->{'POST_INSERT'} ) {
	$WDB::Eval::dbi = $dbi;
	WDB::Eval::eval($fdf->{'NAME'}." POST_INSERT", $fdf->{'POST_INSERT'} );
    }

    #------------------------
    # PRINT RESULT.
    #------------------------

    $fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'insert') );
    $fdf->print_html;
}

1;
