#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 action_query

The 'query' action for WDB.

=head1 Description

This module is automatically loaded by WDB when the 'query' action is
used.

=head1 Functions
=cut#--------------------------------------------------------------------------


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 action_query

Queries the database.

=cut
#------------------------------------------------------------------------------
sub action_query
{
    my($cgi,$fdf) = @_;
    my($dbi,@keys,$key);
    my($start,$maxrows,$rows);

    print main::DEBUG "*** action_query ***\n" if $main::debug;

    #------------------------
    # LOAD DBI
    #------------------------
    $dbi = load_dbi($fdf->{'DATABASE'});

    #------------------------
    # COMPOSE SQL
    #------------------------

    $fdf->verify_query( $cgi );		# 
    $dbi->prepare_select( $cgi, $fdf );	# Still need cgi here ? 

    #------------------------
    # PRINT RESULT.
    #------------------------

    $fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'tab') );

    $start     = $cgi->param('wdb_start');
    $WDB::rows = $fdf->{ldf}->{rowdef_args}->{ROWS};

    while ( $start-- > 0 ) {
	$dbi->nextrow();
    }

    $WDB::Eval::row_no = $cgi->param('wdb_start');

    while( $dbi->load_next_row($fdf) and $WDB::rows-- > 0 ) {
	$fdf->add_row;
	$WDB::Eval::row_no++;
    }
    if ( $WDB::rows == $fdf->{ldf}->{rowdef_args}->{ROWS} ) {
	$fdf->no_rows_found;
    }

    $fdf->print_html;
    $dbi->close;
}

1;
