#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 action_query2

The 'query' action for WDB.

=head1 Description

This module is automatically loaded by WDB when the 'query' action is
used.

=head1 Functions
=cut#--------------------------------------------------------------------------


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 action_query2

Queries the database.

=cut
#------------------------------------------------------------------------------
sub action_query2
{
    my($cgi,$fdf) = @_;
    my($dbi,@keys,$key);
    my($start,$maxrows,$rows);

    print main::DEBUG "*** action_query ***\n" if $main::debug;

    #------------------------
    # LOAD DBI
    #------------------------
    $dbi = load_dbi($fdf->{'DATABASE'});

    #------------------------
    # COMPOSE SQL
    #------------------------

    $fdf->verify_query( $cgi );		# 
#    $dbi->prepare_select( $cgi, $fdf );	# Still need cgi here ? 

    #------------------------
    # Check that at least one field is non-empty...
    #------------------------
    if (defined ($fdf->{'NO_EMPTY_SEARCH'}))  
    {
        my $SearchIsEmpty = 1;    
        foreach $f ( @{$fdf->{fields}} ) 
        {
	    if ( defined ($f->{no_empty_search}) ) 
            {	
	        if (($f->{value} ne '') && (($f->{value}) ne '%'))  
		{
		    $SearchIsEmpty = 0;
                    last;
		}
	    }
	}

	if ($SearchIsEmpty) 
	{
	    $fdf->layout( 'err_msg_empty_search');
	    $fdf->print_html();
	    exit;
	}
    }

    #------------------------
    # COMPOSE SQL
    #------------------------

#    $fdf->verify_query( $cgi );		# 
    $dbi->prepare_select( $cgi, $fdf );	# Still need cgi here ? 

    #------------------------
    #------------------------
    # PRINT RESULT.
    #------------------------

    $fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'tab') );

    $start     = $cgi->param('wdb_start');
    $WDB::rows = $fdf->{ldf}->{rowdef_args}->{ROWS};

    while ( $start-- > 0 ) {
	$dbi->nextrow();
    }

    while( $dbi->load_next_row($fdf) and $WDB::rows-- > 0 ) {
	$fdf->add_row;
    }
    if ( $WDB::rows == $fdf->{ldf}->{rowdef_args}->{ROWS} ) {
	$fdf->no_rows_found;
    }

    $fdf->print_html;
    $dbi->close;
}

1;
