#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 action_upd_form

The 'upd_form' action for WDB.

=head1 Description

Retrieves information from the database and produces an update form
in HTML for updataing the given row. The unique keys of the row
should be specified.

This module is automatically loaded by WDB when the 'upd_form' action is
used.

=head1 Functions
=cut#--------------------------------------------------------------------------


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 action_upd_form

Queries the database, and produces a HTML form with the result.

=cut
#------------------------------------------------------------------------------
sub action_upd_form
{
    my($cgi,$fdf) = @_;
    my($dbi,@keys,$key);

    print main::DEBUG "*** action_upd_form ***\n" if $main::debug;

    #------------------------
    # LOAD DBI
    #------------------------
    $dbi = load_dbi($fdf->{'DATABASE'});

    #------------------------
    # COMPOSE SQL
    #------------------------

    if ( ! $cgi->param('wdb_keys') ) {
	die "No keys defined for update !";
    }

    $fdf->verify_query( $cgi );		 
    $dbi->prepare_select( $cgi, $fdf );

    #------------------------
    # PRINT RESULT.
    #------------------------

    $fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'upd_form') );
    if ( $dbi->load_next_row($fdf) ) {
	# Set error messages if any...
	foreach $f ( @{$fdf->{fields}} ) {
	    $f->verify( $f->{value} ) 
	}
	$fdf->add_row;
    } else {
	die "Not Found \n";
    }
    if ( $dbi->load_next_row($fdf) ) {
	die "Keys not unique !";
    }
    $fdf->print_html;
    $dbi->close;
}

1;
