#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head1 action_update

The 'update' action for WDB.

=head1 Description

Updates a row in the database. Called from the fomr generated by the 'upd_form'
action.

This module is automatically loaded by WDB when the 'update' action is
used.

=head1 Functions
=cut#--------------------------------------------------------------------------


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 action_update

Updates the database.

=cut
#------------------------------------------------------------------------------
sub action_update
{
    my($cgi,$fdf) = @_;
    my($dbi,@keys,$key);
    my($val);

    print main::DEBUG "*** action_update ***\n" if $main::debug;

    #------------------------
    # LOAD DBI
    #------------------------
    $dbi = load_dbi($fdf->{'DATABASE'});

    #------------------------
    # PRE UPDATE ACTION ?
    #------------------------
    if ( $fdf->{'PRE_UPDATE'} ) {
	$WDB::Eval::dbi = $dbi;
	WDB::Eval::eval($fdf->{'NAME'}." PRE_UPDATE", $fdf->{'PRE_UPDATE'} );
    }

    #------------------------
    # VERIFY
    #------------------------
    if ( ! $fdf->verify($cgi) ) {

#$WDB::Eval::ERRORMSG = "<FONT SIZE=+1 COLOR=red>Can't update, see below for errors</FONT>";
	$WDB::Eval::ERRORMSG .= '<FONT SIZE=+1 COLOR=red>'.$main::MSG{CANT_UPDATE}.'</FONT>';

        #-----------
	# Set keys
        #-----------
	if ( $in{wdb_keys} ) {
	    @keys = split( /::/, $in{wdb_keys});
	    foreach $key ( @{$fdf->{keys}} ) {
	       $val = shift(@keys);
	       $fdf->{field}{$key}->set_value( $val );
	       $in{$key} = $val;
	    }
	}

        #-----------------------------------------------------
        # Print the update form again with error messages.
        #-----------------------------------------------------
	$fdf->layout( ( $cgi->param('wdb_lastldf') ? $cgi->param('wdb_lastldf') : 'upd_form') );
	$fdf->add_row;
	$fdf->print_html;
	return;
    } else {
	$WDB::Eval::ERRORMSG = '';
    }

    #------------------------
    # COMPOSE SQL
    #------------------------

    if ( ! $dbi->update( $cgi, $fdf ) ) {
        my($err_code,$err_num, $err_msg) = $dbi->getLastError();
	if ($err_code eq $WDB::DBI::ERR_UNIQ ) {
	    $WDB::Eval::ERRORMSG = '<FONT SIZE=+1 COLOR=red>'
		    . $main::MSG{CANT_UPDATE} .'<BR>'
		    . $main::MSG{DBERR_UNIQE}
		    .'</FONT>';
	} else {
	    $WDB::Eval::ERRORMSG = '<FONT SIZE=+1 COLOR=red>'
		    . $main::MSG{CANT_UPDATE} .'<BR>'
		    .'</FONT>'
		    ."( [$err_code][$err_num] <I>$err_msg</I>)"
		    ;
	}
	$fdf->layout( ( $cgi->param('wdb_lastldf') ? $cgi->param('wdb_lastldf') : 'upd_form') );
	$fdf->print_html;
	return;
    }

    #------------------------
    # POST UPDATE ACTION ?
    #------------------------
    if ( $fdf->{'POST_UPDATE'} ) {
	$WDB::Eval::dbi = $dbi;
	WDB::Eval::eval($fdf->{'NAME'}." POST_UPDATE", $fdf->{'POST_UPDATE'} );
    }

    #------------------------
    # PRINT RESULT.
    #------------------------

    $fdf->layout( ( $cgi->param('wdb_ldf') ? $cgi->param('wdb_ldf') : 'update') );
    $fdf->print_html;
}

1;
