#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=head2 verify_url( value )

Verifies that the given value is valid for this field.

Returns an error message. An empty string indicates success.

=cut
#------------------------------------------------------------------------------
sub verify_url
{
    my($val)      = shift;
    my($errormsg) = '';

    return unless $val;

    if ( $val !~ /^http:\/\// ) {
	$errormsg .= " This does not look like a URL. Expected http://...";
    }

    return $errormsg;
}

